<?php
/**
 * Functions which enhance the theme by hooking into WordPress
 *
 * @package property_dealer
 */

function property_dealer_body_classes( $property_dealer_classes ) {
	// Adds a class of hfeed to non-singular pages.
	if ( ! is_singular() ) {
		$property_dealer_classes[] = 'hfeed';
	}

	// Adds a class of no-sidebar when there is no sidebar present.
	if ( ! is_active_sidebar( 'sidebar-1' ) ) {
		$property_dealer_classes[] = 'no-sidebar';
	}

	$property_dealer_classes[] = property_dealer_sidebar_layout();

	return $property_dealer_classes;
}
add_filter( 'body_class', 'property_dealer_body_classes' );

/**
 * Add a pingback url auto-discovery header for single posts, pages, or attachments.
 */
function property_dealer_pingback_header() {
	if ( is_singular() && pings_open() ) {
		printf( '<link rel="pingback" href="%s">', esc_url( get_bloginfo( 'pingback_url' ) ) );
	}
}
add_action( 'wp_head', 'property_dealer_pingback_header' );


/**
 * Get all posts for customizer Post content type.
 */
function property_dealer_get_post_choices() {
	$property_dealer_choices = array( '' => esc_html__( '--Select--', 'property-dealer' ) );
	$property_dealer_args    = array( 'numberposts' => -1 );
	$property_dealer_posts   = get_posts( $property_dealer_args );

	foreach ( $property_dealer_posts as $property_dealer_post ) {
		$property_dealer_id             = $property_dealer_post->ID;
		$property_dealer_title          = $property_dealer_post->post_title;
		$property_dealer_choices[ $property_dealer_id ] = $property_dealer_title;
	}

	return $property_dealer_choices;
}

/**
 * Get all pages for customizer Page content type.
 */
function property_dealer_get_page_choices() {
	$property_dealer_choices = array( '' => esc_html__( '--Select--', 'property-dealer' ) );
	$property_dealer_pages   = get_pages();

	foreach ( $property_dealer_pages as $property_dealer_page ) {
		$property_dealer_choices[ $property_dealer_page->ID ] = $property_dealer_page->post_title;
	}

	return $property_dealer_choices;
}

/**
 * Get all categories for customizer Category content type.
 */
function property_dealer_get_post_cat_choices() {
	$property_dealer_choices = array( '' => esc_html__( '--Select--', 'property-dealer' ) );
	$property_dealer_cats    = get_categories();

	foreach ( $property_dealer_cats as $property_dealer_cat ) {
		$property_dealer_choices[ $property_dealer_cat->term_id ] = $property_dealer_cat->name;
	}

	return $property_dealer_choices;
}

/**
 * Get all donation forms for customizer form content type.
 */
function property_dealer_get_post_donation_form_choices() {
	$property_dealer_choices = array( '' => esc_html__( '--Select--', 'property-dealer' ) );
	$property_dealer_posts   = get_posts(
		array(
			'post_type'   => 'give_forms',
			'numberposts' => -1,
		)
	);
	foreach ( $property_dealer_posts as $property_dealer_post ) {
		$property_dealer_choices[ $property_dealer_post->ID ] = $property_dealer_post->post_title;
	}
	return $property_dealer_choices;
}

if ( ! function_exists( 'property_dealer_excerpt_length' ) ) :
	/**
	 * Excerpt length.
	 */
	function property_dealer_excerpt_length( $property_dealer_length ) {
		if ( is_admin() ) {
			return $property_dealer_length;
		}

		return get_theme_mod( 'property_dealer_excerpt_length', 20 );
	}
endif;
add_filter( 'excerpt_length', 'property_dealer_excerpt_length', 999 );

if ( ! function_exists( 'property_dealer_excerpt_more' ) ) :
	/**
	 * Excerpt more.
	 */
	function property_dealer_excerpt_more( $property_dealer_more ) {
		if ( is_admin() ) {
			return $property_dealer_more;
		}

		return '&hellip;';
	}
endif;
add_filter( 'excerpt_more', 'property_dealer_excerpt_more' );

if ( ! function_exists( 'property_dealer_sidebar_layout' ) ) {
	/**
	 * Get sidebar layout.
	 */
	function property_dealer_sidebar_layout() {
		$property_dealer_sidebar_position      = get_theme_mod( 'property_dealer_sidebar_position', 'right-sidebar' );
		$property_dealer_sidebar_position_page = get_theme_mod( 'property_dealer_page_sidebar_position', 'right-sidebar' );

		if ( is_page() ) {
			$property_dealer_sidebar_position = $property_dealer_sidebar_position_page;
		}

		return $property_dealer_sidebar_position;
	}
}

if ( ! function_exists( 'property_dealer_is_sidebar_enabled' ) ) {
	/**
	 * Check if sidebar is enabled.
	 */
	function property_dealer_is_sidebar_enabled() {
		$property_dealer_sidebar_position      = get_theme_mod( 'property_dealer_sidebar_position', 'right-sidebar' );
		$property_dealer_sidebar_position_page = get_theme_mod( 'property_dealer_page_sidebar_position', 'right-sidebar' );

		$property_dealer_sidebar_enabled = true;
		if ( is_home() || is_archive() || is_search() ) {
			if ( 'no-sidebar' === $property_dealer_sidebar_position ) {
				$property_dealer_sidebar_enabled = false;
			}
		} elseif ( is_page() ) {
			if ( 'no-sidebar' === $property_dealer_sidebar_position || 'no-sidebar' === $property_dealer_sidebar_position_page ) {
				$property_dealer_sidebar_enabled = false;
			}
		}
		return $property_dealer_sidebar_enabled;
	}
}

if ( ! function_exists( 'property_dealer_get_homepage_sections ' ) ) {
	/**
	 * Returns homepage sections.
	 */
	function property_dealer_get_homepage_sections() {
		$property_dealer_sections = array(
			'banner'  => esc_html__( 'Banner Section', 'property-dealer' ),
			'properties' => esc_html__( 'Properties Section', 'property-dealer' ),
		);
		return $property_dealer_sections;
	}
}

/**
 * Renders customizer section link
 */
function property_dealer_section_link( $property_dealer_section_id ) {
	$property_dealer_section_name      = str_replace( 'property_dealer_', ' ', $property_dealer_section_id );
	$property_dealer_section_name      = str_replace( '_', ' ', $property_dealer_section_name );
	$property_dealer_starting_notation = '#';
	?>
	<span class="section-link">
		<span class="section-link-title"><?php echo esc_html( $property_dealer_section_name ); ?></span>
	</span>
	<style type="text/css">
		<?php echo $property_dealer_starting_notation . $property_dealer_section_id; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped ?>:hover .section-link {
			visibility: visible;
		}
	</style>
	<?php
}

/**
 * Adds customizer section link css
 */
function property_dealer_section_link_css() {
	if ( is_customize_preview() ) {
		?>
		<style type="text/css">
			.section-link {
				visibility: hidden;
				background-color: black;
				position: relative;
				top: 80px;
				z-index: 99;
				left: 40px;
				color: #fff;
				text-align: center;
				font-size: 20px;
				border-radius: 10px;
				padding: 20px 10px;
				text-transform: capitalize;
			}

			.section-link-title {
				padding: 0 10px;
			}

			.banner-section {
				position: relative;
			}

			.banner-section .section-link {
				position: absolute;
				top: 100px;
			}
		</style>
		<?php
	}
}
add_action( 'wp_head', 'property_dealer_section_link_css' );

/**
 * Breadcrumb.
 */
function property_dealer_breadcrumb( $property_dealer_args = array() ) {
	if ( ! get_theme_mod( 'property_dealer_enable_breadcrumb', true ) ) {
		return;
	}

	$property_dealer_args = array(
		'show_on_front' => false,
		'show_title'    => true,
		'show_browse'   => false,
	);
	breadcrumb_trail( $property_dealer_args );
}
add_action( 'property_dealer_breadcrumb', 'property_dealer_breadcrumb', 10 );

/**
 * Add separator for breadcrumb trail.
 */
function property_dealer_breadcrumb_trail_print_styles() {
	$property_dealer_breadcrumb_separator = get_theme_mod( 'property_dealer_breadcrumb_separator', '/' );

	$property_dealer_style = '
		.trail-items li::after {
			content: "' . $property_dealer_breadcrumb_separator . '";
		}'; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped

	$property_dealer_style = apply_filters( 'property_dealer_breadcrumb_trail_inline_style', trim( str_replace( array( "\r", "\n", "\t", '  ' ), '', $property_dealer_style ) ) );

	if ( $property_dealer_style ) {
		echo "\n" . '<style type="text/css" id="breadcrumb-trail-css">' . $property_dealer_style . '</style>' . "\n"; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped
	}
}
add_action( 'wp_head', 'property_dealer_breadcrumb_trail_print_styles' );

/**
 * Pagination for archive.
 */
function property_dealer_render_posts_pagination() {
	$property_dealer_is_pagination_enabled = get_theme_mod( 'property_dealer_enable_pagination', true );
	if ( $property_dealer_is_pagination_enabled ) {
		$property_dealer_pagination_type = get_theme_mod( 'property_dealer_pagination_type', 'default' );
		if ( 'default' === $property_dealer_pagination_type ) :
			the_posts_navigation();
		else :
			the_posts_pagination();
		endif;
	}
}
add_action( 'property_dealer_posts_pagination', 'property_dealer_render_posts_pagination', 10 );

/**
 * Pagination for single post.
 */
function property_dealer_render_post_navigation() {
	the_post_navigation(
		array(
			'prev_text' => '<span>&#10229;</span> <span class="nav-title">%title</span>',
			'next_text' => '<span class="nav-title">%title</span> <span>&#10230;</span>',
		)
	);
}
add_action( 'property_dealer_post_navigation', 'property_dealer_render_post_navigation' );

/**
 * Adds footer copyright text.
 */
function property_dealer_output_footer_copyright_content() {
    $property_dealer_theme_data = wp_get_theme();
    $property_dealer_copyright_text = get_theme_mod('property_dealer_footer_copyright_text');

	if (!empty($property_dealer_copyright_text)) {
        $property_dealer_text = $property_dealer_copyright_text;
    } else {

		$property_dealer_default_text = '<a href="'. esc_url(__('https://asterthemes.com/products/property-dealer','property-dealer')) . '" target="_blank"> ' . esc_html($property_dealer_theme_data->get('Name')) . '</a>' . '&nbsp;' . esc_html__('by', 'property-dealer') . '&nbsp;<a target="_blank" href="' . esc_url($property_dealer_theme_data->get('AuthorURI')) . '">' . esc_html(ucwords($property_dealer_theme_data->get('Author'))) . '</a>';
		/* translators: %s: WordPress.org URL */
        $property_dealer_default_text .= sprintf(esc_html__(' | Powered by %s', 'property-dealer'), '<a href="' . esc_url(__('https://wordpress.org/', 'property-dealer')) . '" target="_blank">WordPress</a>. ');

        $property_dealer_text = $property_dealer_default_text;

    }
    ?>
    <span><?php echo wp_kses_post($property_dealer_text); ?></span>
    <?php
}
add_action('property_dealer_footer_copyright', 'property_dealer_output_footer_copyright_content');

/* Footer Social Icons */ 
function property_dealer_footer_social_links() {

    if ( get_theme_mod('property_dealer_enable_footer_icon_section', true) ) {

            ?>
            <div class="socialicons">
                <?php if ( get_theme_mod('property_dealer_footer_facebook_link', 'https://www.facebook.com/') != '' ) { ?>
                    <a target="_blank" href="<?php echo esc_url(get_theme_mod('property_dealer_footer_facebook_link', 'https://www.facebook.com/')); ?>">
                        <i class="<?php echo esc_attr(get_theme_mod('property_dealer_facebook_icon', 'fab fa-facebook-f')); ?>"></i>
                        <span class="screen-reader-text"><?php esc_html_e('Facebook', 'property-dealer'); ?></span>
                    </a>
                <?php } ?>
                <?php if ( get_theme_mod('property_dealer_footer_twitter_link', 'https://x.com/') != '' ) { ?>
                    <a target="_blank" href="<?php echo esc_url(get_theme_mod('property_dealer_footer_twitter_link', 'https://x.com/')); ?>">
                        <i class="<?php echo esc_attr(get_theme_mod('property_dealer_twitter_icon', 'fab fa-twitter')); ?>"></i>
                        <span class="screen-reader-text"><?php esc_html_e('Twitter', 'property-dealer'); ?></span>
                    </a>
                <?php } ?>
				<?php if ( get_theme_mod('property_dealer_footer_instagram_link', 'https://www.instagram.com/') != '' ) { ?>
                    <a target="_blank" href="<?php echo esc_url(get_theme_mod('property_dealer_footer_instagram_link', 'https://www.instagram.com/')); ?>">
                        <i class="<?php echo esc_attr(get_theme_mod('property_dealer_instagram_icon', 'fab fa-instagram')); ?>"></i>
                        <span class="screen-reader-text"><?php esc_html_e('Instagram', 'property-dealer'); ?></span>
                    </a>
                <?php } ?>
                <?php if ( get_theme_mod('property_dealer_footer_linkedin_link', 'https://in.linkedin.com/') != '' ) { ?>
                    <a target="_blank" href="<?php echo esc_url(get_theme_mod('property_dealer_footer_linkedin_link', 'https://in.linkedin.com/')); ?>">
                        <i class="<?php echo esc_attr(get_theme_mod('property_dealer_linkedin_icon', 'fab fa-linkedin')); ?>"></i>
                        <span class="screen-reader-text"><?php esc_html_e('Linkedin', 'property-dealer'); ?></span>
                    </a>
                <?php } ?>
				<?php if ( get_theme_mod('property_dealer_footer_youtube_link', 'https://www.youtube.com/') != '' ) { ?>
                    <a target="_blank" href="<?php echo esc_url(get_theme_mod('property_dealer_footer_youtube_link', 'https://www.youtube.com/')); ?>">
                        <i class="<?php echo esc_attr(get_theme_mod('property_dealer_youtube_icon', 'fab fa-youtube')); ?>"></i>
                        <span class="screen-reader-text"><?php esc_html_e('Youtube', 'property-dealer'); ?></span>
                    </a>
                <?php } ?>
            </div>
            <?php
    }
}
add_action('wp_footer', 'property_dealer_footer_social_links');

if ( ! function_exists( 'property_dealer_footer_widget' ) ) :
	function property_dealer_footer_widget() {
		$property_dealer_footer_widget_column = get_theme_mod('property_dealer_footer_widget_column','4');

		$property_dealer_column_class = '';
		if ($property_dealer_footer_widget_column == '1') {
			$property_dealer_column_class = 'one-column';
		} elseif ($property_dealer_footer_widget_column == '2') {
			$property_dealer_column_class = 'two-columns';
		} elseif ($property_dealer_footer_widget_column == '3') {
			$property_dealer_column_class = 'three-columns';
		} else {
			$property_dealer_column_class = 'four-columns';
		}
	
		if($property_dealer_footer_widget_column !== ''): 
		?>
		<div class="dt_footer-widgets <?php echo esc_attr($property_dealer_column_class); ?> wow bounceInUp delay-1000" data-wow-duration="2s">
			<div class="footer-widgets-column">
				<?php
				$footer_widgets_active = false;

				// Loop to check if any footer widget is active
				for ($property_dealer_i = 1; $property_dealer_i <= $property_dealer_footer_widget_column; $property_dealer_i++) {
					if (is_active_sidebar('footer-widget-' . $property_dealer_i)) {
						$footer_widgets_active = true;
						break;
					}
				}

				if ($footer_widgets_active) {
					// Display active footer widgets
					for ($property_dealer_i = 1; $property_dealer_i <= $property_dealer_footer_widget_column; $property_dealer_i++) {
						if (is_active_sidebar('footer-widget-' . $property_dealer_i)) : ?>
							<div class="footer-one-column">
								<?php dynamic_sidebar('footer-widget-' . $property_dealer_i); ?>
							</div>
						<?php endif;
					}
				} else {
				?>
				<div class="footer-one-column default-widgets">
					<aside id="search-2" class="widget widget_search default_footer_search">
						<div class="widget-header">
							<h4 class="widget-title"><?php esc_html_e('Search Here', 'property-dealer'); ?></h4>
						</div>
						<?php get_search_form(); ?>
					</aside>
				</div>
				<div class="footer-one-column default-widgets">
					<aside id="recent-posts-2" class="widget widget_recent_entries">
						<h2 class="widget-title"><?php esc_html_e('Recent Posts', 'property-dealer'); ?></h2>
						<ul>
							<?php
							$recent_posts = wp_get_recent_posts(array(
								'numberposts' => 5,
								'post_status' => 'publish',
							));
							foreach ($recent_posts as $post) {
								echo '<li><a href="' . esc_url(get_permalink($post['ID'])) . '">' . esc_html($post['post_title']) . '</a></li>';
							}
							wp_reset_query();
							?>
						</ul>
					</aside>
				</div>
				<div class="footer-one-column default-widgets">
					<aside id="recent-comments-2" class="widget widget_recent_comments">
						<h2 class="widget-title"><?php esc_html_e('Recent Comments', 'property-dealer'); ?></h2>
						<ul>
							<?php
							$recent_comments = get_comments(array(
								'number' => 5,
								'status' => 'approve',
							));
							foreach ($recent_comments as $comment) {
								echo '<li><a href="' . esc_url(get_comment_link($comment)) . '">' .
									/* translators: %s: details. */
									sprintf(esc_html__('Comment on %s', 'property-dealer'), get_the_title($comment->comment_post_ID)) .
									'</a></li>';
							}
							?>
						</ul>
					</aside>
				</div>
				<div class="footer-one-column default-widgets">
					<aside id="categories" class="widget py-3" role="complementary" aria-label="<?php esc_attr_e('footer1', 'property-dealer'); ?>">
                        <h3 class="widget-title"><?php esc_html_e('Categories', 'property-dealer'); ?></h3>
                        <ul>
                            <?php wp_list_categories('title_li='); ?>
                        </ul>
                    </aside>
				</div>
			</div>
			<?php } ?>
		</div>
		<?php
		endif;
	}
	endif;
add_action( 'property_dealer_footer_widget', 'property_dealer_footer_widget' );


function property_dealer_footer_text_transform_css() {
    $property_dealer_footer_text_transform = get_theme_mod('footer_text_transform', 'none');
    ?>
    <style type="text/css">
        .site-footer h4,footer#colophon h2.wp-block-heading,footer#colophon .widgettitle,footer#colophon .widget-title {
            text-transform: <?php echo esc_html($property_dealer_footer_text_transform); ?>;
        }
    </style>
    <?php
}
add_action('wp_head', 'property_dealer_footer_text_transform_css');

/**
 * GET START FUNCTION
 */

 function property_dealer_getpage_css($hook) {
	wp_enqueue_script( 'property-dealer-admin-script', get_template_directory_uri() . '/resource/js/property-dealer-admin-notice-script.js', array( 'jquery' ) );
    wp_localize_script( 'property-dealer-admin-script', 'property_dealer_ajax_object',
        array( 'ajax_url' => admin_url( 'admin-ajax.php' ) )
    );
    wp_enqueue_style( 'property-dealer-notice-style', get_template_directory_uri() . '/resource/css/notice.css' );
}

add_action( 'admin_enqueue_scripts', 'property_dealer_getpage_css' );

add_action('wp_ajax_property_dealer_dismissable_notice', 'property_dealer_dismissable_notice');
function property_dealer_switch_theme() {
    delete_user_meta(get_current_user_id(), 'property_dealer_dismissable_notice');
}
add_action('after_switch_theme', 'property_dealer_switch_theme');
function property_dealer_dismissable_notice() {
    update_user_meta(get_current_user_id(), 'property_dealer_dismissable_notice', true);
    die();
}

function property_dealer_deprecated_hook_admin_notice() {
    global $pagenow;
    
    // Check if the current page is the one where you don't want the notice to appear
    if ( $pagenow === 'themes.php' && isset( $_GET['page'] ) && $_GET['page'] === 'property-dealer-getting-started' ) {
        return;
    }

    $dismissed = get_user_meta( get_current_user_id(), 'property_dealer_dismissable_notice', true );
    if ( !$dismissed) { ?>
        <div class="getstrat updated notice notice-success is-dismissible notice-get-started-class">
            <div class="at-admin-content" >
                <h2><?php esc_html_e('Welcome to Property Dealer', 'property-dealer'); ?></h2>
                <p><?php _e('Explore the features of our Pro Theme and take your Property Dealer journey to the next level.', 'property-dealer'); ?></p>
                <p ><?php _e('Get Started With Theme By Clicking On Getting Started.', 'property-dealer'); ?><p>
                <div style="display: flex; justify-content: center; align-items:center; flex-wrap: wrap; gap: 5px">
                    <a class="admin-notice-btn button button-primary button-hero" href="<?php echo esc_url( admin_url( 'themes.php?page=property-dealer-getting-started' )); ?>"><?php esc_html_e( 'Get started', 'property-dealer' ) ?></a>
                    <a  class="admin-notice-btn button button-primary button-hero" target="_blank" href="https://demo.asterthemes.com/property-dealer/"><?php esc_html_e('View Demo', 'property-dealer') ?></a>
                    <a  class="admin-notice-btn button button-primary button-hero" target="_blank" href="<?php echo esc_url( PROPERTY_DEALER_PREMIUM_PAGE ); ?>"><?php esc_html_e('Buy Now', 'property-dealer') ?></a>
                    <a  class="admin-notice-btn button button-primary button-hero" target="_blank" href="<?php echo esc_url( PROPERTY_DEALER_BUNDLE_PAGE ); ?>"><?php esc_html_e('Get Bundle', 'property-dealer') ?></a>
                </div>
            </div>
            <div class="at-admin-image">
                <img style="width: 100%;max-width: 320px;line-height: 40px;display: inline-block;vertical-align: top;border: 2px solid #ddd;border-radius: 4px;" src="<?php echo esc_url(get_stylesheet_directory_uri()) .'/screenshot.png'; ?>" />
            </div>
        </div>
    <?php }
}
add_action( 'admin_notices', 'property_dealer_deprecated_hook_admin_notice' );


//Admin Notice For Getstart
function property_dealer_ajax_notice_handler() {
    if ( isset( $_POST['type'] ) ) {
        $type = sanitize_text_field( wp_unslash( $_POST['type'] ) );
        update_option( 'dismissed-' . $type, TRUE );
    }
}